// ++++++++++++++++++++++++++++++++++++++++ //
// 編集項目ここから
// 参考 -> https://apps.jp.net/information/about_project_file/
// 2022年8月時点でインタースティシャル広告は非表示・OpenAdを表示する設定を推奨しています。
// ++++++++++++++++++++++++++++++++++++++++ //

var admobid = {}
var admobid_ios = {}

// 1. 以下のca-app-pub-xxxxx/yyyyyのxxxxxとyyyyy部分を自分の広告IDの数値に変更してください
var admobid = {
    // バナー型広告の広告IDを入力
    banner: 'ca-app-pub-2653369295607612/8692709202',
    // インタースティシャル型広告の広告IDを入力
    interstitial: 'ca-app-pub-2653369295607612/1892479632',
    // OpenAd広告の広告IDを入力
    open: 'ca-app-pub-2653369295607612/7145678456',
}

// IOS 用の広告IDはこちらに設定して下さい
admobid_ios = {
    // バナー型広告の広告IDを入力
    banner: 'ca-app-pub-3940256099942544/6300978111',
    // インタースティシャル型広告の広告IDを入力
    interstitial: 'ca-app-pub-2653369295607612/6975294041',
    // OpenAd広告の広告IDを入力
    open: 'ca-app-pub-2653369295607612/4200036630',
}

// 2. アプリ起動時広告（OpenAd）を利用する場合はtrue/利用しない場合はfalse
var use_open_ad = true;
// 3. OpenAd表示間隔（指定した秒が経過するまで再度広告は表示されません）
var open_ad_interval = 60;

// 4. 全画面広告広告（interstitialAd）を利用する場合はtrue/利用しない場合はfalse
var use_interstitial = false;
// 5. interstitialAd表示間隔（指定した秒が経過するまで再度広告は表示されません）
var interstitial_ad_interval = 30;

// ++++++++++++++++++++++++++++++++++++++++ //
// 編集項目ここまで
// ++++++++++++++++++++++++++++++++++++++++ //

// 以下の設定は変更不要です
var show_start_up_banner = true;
var show_interstitial_banner = false;


// バナー広告に関する処理
let bannerAd;
// インタースティシャルに関する処理
let interstitialAd;
// Open Adに関する処理
var openAd;

// DeviceのReady時に広告の初期化
document.addEventListener('deviceready', async () => {
  if (cordova.platformId === 'ios') {
      admobid = admobid_ios;
  }
  bannerAd = new admob.BannerAd({
    adUnitId: admobid.banner,
    position: 'bottom'
  })


  bannerAd.show()

    if (use_interstitial) {
        interstitialAd = new admob.InterstitialAd({
            adUnitId: admobid.interstitial,
        })

        interstitialAd.on('load', (evt) => {
        // evt.ad
        })
    
        await interstitialAd.load()
    }

    if (use_open_ad) {        
        openAd = new admob.AppOpenAd({
            adUnitId: admobid.open,
        })
        openAd.on('load', (evt) => {
            showOpenAd();
        })
        await openAd.load();
    }

}, false);



if (use_interstitial) {



function showinterstitialAd()
{
    if (!show_interstitial_banner) {
        return;
    } else {
        console.log('インタースティシャル広告を表示してタイマーをリセットします');
        interstitialAd.show();
        show_interstitial_banner = false;
        setTimeout(function(){show_interstitial_banner = true; console.log(interstitial_ad_interval + '秒経過')}, interstitial_ad_interval*1000);
    }
    
}

document.addEventListener('admob.ad.dismiss', async () => {
  // Once a interstitial ad is shown, it cannot be shown again.
  // Starts loading the next interstitial ad as soon as it is dismissed.
  await interstitialAd.load()
})

}

if (use_open_ad) {




document.addEventListener('admob.ad.show', async (evt) => {
  if (evt.ad instanceof admob.AppOpenAd) {
    console.log("Open Adが表示されました");
    // 指定時間経過するまでは全画面広告を非表示
    show_start_up_banner = false;
    // インタースティシャルも指定時間表示させない
    show_interstitial_banner = false;

    console.log('set timeout');
    setTimeout(function() {
        show_start_up_banner = true;
        console.log(open_ad_interval + '秒経過')
    }, open_ad_interval*1000);

    setTimeout(function() {
        
        show_interstitial_banner = true;
        console.log(interstitial_ad_interval + '秒経過')
    }, interstitial_ad_interval*1000);
   }
})
}

function showOpenAd()
{
 
    if (show_start_up_banner == false) {
        console.log('show_start_up_bannerがfalseなので広告は表示しません');
        return;
    } else {
         if ( !openAd.show()) {
         openAd.load()
        }
    }

}

if (use_interstitial) {
document.addEventListener('show', function(event) {
  var page = event.target;
  if (page.id == "home" && show_interstitial_banner) {
    console.log("トップページが表示されたので全画面広告を表示します");
    showinterstitialAd();
  }
});

document.addEventListener('hide', function(event) {
  var page = event.target;
  if (page.id == "home") {
    console.log("トップページから移動したので指定時間経過後インタースティシャル広告のflagをtrueにします");
    show_interstitial_banner = false;
    setTimeout(function() {
        show_interstitial_banner = true;
        console.log(interstitial_ad_interval + '秒経過')
    }, interstitial_ad_interval*1000);
    
  }
});
}

// アプリがバックグラウンドから戻った時の処理
document.addEventListener('resume', async () => {
    // 重複表示を回避するため一旦show_interstitial_bannerをfalseにする
    show_interstitial_banner = false;
    if (use_open_ad) {
        if (show_start_up_banner == false) {
            console.log("show_start_up_bannerがfalseなので広告は表示しません");
            return;
        }
        // OpenAdを表示させる
        if (!await openAd.show()) {
            await openAd.load()
        }
    }
})


// トラッキングの許可
document.addEventListener('deviceready', async () => {
  if (cordova.platformId === 'ios') {
    const status = await consent.trackingAuthorizationStatus()
    /*
      trackingAuthorizationStatus:
      0 = notDetermined
      1 = restricted
      2 = denied
      3 = authorized
    */
    const statusNew = await consent.requestTrackingAuthorization()
  }

  const consentStatus = await consent.getConsentStatus()
  if (consentStatus === consent.ConsentStatus.Required) {
    await consent.requestInfoUpdate()
  }

  const formStatus = await consent.getFormStatus()
  if (formStatus === consent.FormStatus.Available) {
      const form = await consent.loadForm()
      form.show()
  }
}, false)